//                                                                  
// Copyright  2011 Lidor Systems.
// All Rights Reserved.
//
// This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
// either express or implied.                        
//

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace IULB_RichContent
{
    public partial class Form1 : Form
    {
        private String assemblyFullPath = Application.ExecutablePath;
        
        public Form1()
        {
            InitializeComponent();
            InitList();
        }

        private void InitList()
        {
            this.listBox1.ItemSpacing = 2;
            this.listBox1.ScrollBarUseTheme = true;

            this.listBox1.SuspendUpdate();

            this.listBox1.NormalItemStyle.BorderColor = Color.LightGray;

            Product obj = null;
            LidorSystems.IntegralUI.Lists.ListBoxItem item = null;

            for (int i = 0; i < 10; i++)
            {
                item = new LidorSystems.IntegralUI.Lists.ListBoxItem();

                obj = CreateProduct(i);
                item.Content = ApplyTemplate(obj);
                item.Tag = obj;

                ProgressBar ctrlRate = new ProgressBar();
                ctrlRate.Size = new Size(70, 12);
                ctrlRate.Minimum = 0;
                ctrlRate.Maximum = 5;
                ctrlRate.Value = obj.Rating;
                item.Controls.Add(ctrlRate);

                this.listBox1.Items.Add(item);
            }

            this.listBox1.ResumeUpdate();
        }

        private Product CreateProduct(int index)
        {
            Product obj = new Product(index);

            switch (index % 3)
            {
                case 1:
                    obj.Name = "Thringer Rostbratwurst";
                    obj.Category = "Meat";
                    obj.Rating = 2;
                    obj.Price = 123.79f;
                    obj.ImageSource = "meat.jpg";
                    break;

                case 2:
                    obj.Name = "Scottish Longbreads";
                    obj.Category = "Confections";
                    obj.Rating = 4;
                    obj.Price = 12.50f;
                    obj.ImageSource = "confections.jpg";
                    break;

                default:
                    obj.Name = "Ipoh Coffee";
                    obj.Category = "Beverages";
                    obj.Rating = 3;
                    obj.Price = 46.00f;
                    obj.ImageSource = "beverages.jpg";
                    break;
            }

            return obj;
        }

        private String ApplyTemplate(Product obj)
        {
            String content = String.Empty;

            content = "<div>";
            content += "<table cellpadding=\"2\" width=\"100%\">";
            content += "<tr>";
            content += "<td rowspan=\"2\"><img assemblypath=\"" + assemblyFullPath + "\" resource=\"Resources." + obj.ImageSource + "\"></img></td>";
            content += "<td width=\"100%\"><font size=\"10\">" + obj.Name + "</font></td>";
            content += "<td style=\"align:middleright;textcolor:DarkBlue\">" + obj.Category + "</td>";
            content += "<td style=\"align:middlecenter;hovertextcolor:DarkRed\" width=\"50\"><a href=\"" + obj.Name + "\">more ...</a></td>";
            content += "</tr>";
            content += "<tr>";
            content += "<td><control index=\"0\"></control></td>";
            content += "<td style=\"align:middleright\"><b>" + obj.Price.ToString("0.00") + "</b></td>";
            content += "</tr>";
            content += "</table>";
            content += "</div>";

            return content;
        }

        private void listBox1_ItemObjectClicked(object sender, LidorSystems.IntegralUI.ObjectClickEventArgs e)
        {
            if (e.Object is LinkLabel)
            {
                LinkLabel lLabel = (LinkLabel)e.Object;
                String linkData = lLabel.Links[0].LinkData.ToString();

                MessageBox.Show("More info for: " + linkData + " clicked");
            }
        }
    }
}