//                                                                  
// Copyright  2011 Lidor Systems.
// All Rights Reserved.
//
// This SOFTWARE is provided "AS IS", WITHOUT WARRANTY OF ANY KIND.
// either express or implied.                        
//

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;

namespace IULB_RichContent
{
    public class Product : System.Object
    {
        private int _id = -1;
        private String _name = String.Empty;
        private String _category = String.Empty;
        private String _imageSource = String.Empty;
        private double _price = 0.0f;
        private int _rating = 0;

        public Product(int id)
        {
            Init(id, String.Empty, String.Empty, 0, 0);
        }

        public Product(int id, String name, String category)
        {
            Init(id, name, category, 0, 0);
        }

        private void Init(int id, String name, String category, double price, int rating)
        {
            int _id = id;
            String _name = name;
            String _category = category;
            double _price = price;
            int _rating = rating;
        }

        public int ID
        {
            get { return _id; }
        }

        public String Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public String Category
        {
            get { return _category; }
            set { _category = value; }
        }

        public String ImageSource
        {
            get { return _imageSource; }
            set { _imageSource = value; }
        }

        public double Price
        {
            get { return _price; }
            set { _price = value; }
        }

        public int Rating
        {
            get { return _rating; }
            set { _rating = value; }
        }
    }
}
